'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ElementHandling = function () {
    function ElementHandling() {
        _classCallCheck(this, ElementHandling);
    }

    _createClass(ElementHandling, [{
        key: 'selectCheckbox',
        value: function selectCheckbox(selector, option) {
            if (typeof option !== "undefined") {
                var elem = this.element(selector);
                if (elem.isSelected() !== option) {
                    elem.click();
                }
            }
            return this;
        }
    }], [{
        key: 'element',
        value: function element(selector) {
            var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 30000;
            var reverse = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

            browser.waitForVisible(selector, timeout, reverse);
            return $(selector);
        }
    }, {
        key: 'elements',
        value: function elements(selector) {
            var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 30000;

            browser.waitForVisible(selector, timeout);
            return $$(selector);
        }
    }, {
        key: 'isElementVisible',
        value: function isElementVisible(selector) {
            var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5000;

            try {
                browser.waitForVisible(selector, timeout);
            } catch (ex) {
                console.log(ex.toString());
                return false;
            }
            return true;
        }
    }, {
        key: 'isElementEnabled',
        value: function isElementEnabled(selector) {
            var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5000;

            try {
                browser.waitForEnabled(selector, timeout);
            } catch (ex) {
                console.log(ex.toString());
                return false;
            }
            return true;
        }
    }, {
        key: 'scrollIntoViewByXpath',
        value: function scrollIntoViewByXpath(xpathInput) {
            browser.execute(function (xpath) {
                console.log(xpath);
                document.evaluate(xpath, document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null).singleNodeValue.scrollIntoView();
            }, xpathInput);
            browser.scroll(0, -100);
        }
    }, {
        key: 'hoverAndClick',
        value: function hoverAndClick(selector) {
            browser.moveToObject(selector);
            $(selector).click();
        }
    }, {
        key: 'attachFile',
        value: function attachFile(selector, filePath, checkFuntion) {
            if (filePath) {
                browser.chooseFile(selector, filePath);
                console.log('Uploading file: ' + filePath);
                if (typeof checkFuntion !== 'undefined') {
                    browser.waitUntil(checkFuntion === true, 60000, 'Uploading file is unsuccessful.');
                }
            } else {
                throw new Error('No file was input for attachment');
            }
        }
    }]);

    return ElementHandling;
}();

module.exports = ElementHandling;