'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var $ = require('../element/ElementHandling').element;
var http = require('http');
var fs = require('fs');
var crypto = require('crypto');
var url = require('url');

var AttachmentHandling = function () {
    function AttachmentHandling() {
        _classCallCheck(this, AttachmentHandling);
    }

    _createClass(AttachmentHandling, null, [{
        key: 'downloadFile',
        value: function downloadFile(fileLocation, destLocation) {
            var file = fs.createWriteStream(destLocation);
            var request = http.get(fileLocation, function (response) {
                response.pipe(file);
            });
        }
    }, {
        key: 'downloadFileWithCookie',
        value: function downloadFileWithCookie(fileLocation, destLocation) {
            var cookie = browser.getCookie();
            var curUrl = browser.getUrl();
            console.log('FILE location:' + fileLocation);
            console.log('URL: ' + url.parse(curUrl).hostname);
            var file = fs.createWriteStream(destLocation);
            var options = {
                hostname: url.parse(curUrl).hostname,
                port: 80,
                path: fileLocation,
                method: 'GET',
                headers: {
                    'Cookie': cookie[0].name + '=' + cookie[0].value
                }
            };

            var req = http.request(options, function (res) {
                console.log('Writing source file....');
                res.pipe(file);

                res.on('end', function () {
                    console.log('No more data in response.');
                });
            });

            req.on('error', function (e) {
                console.error('problem with request: ' + e.message);
            });
            req.end();
        }
    }, {
        key: 'getFileChecksumSha1',
        value: function getFileChecksumSha1(fileLocation) {
            var checksumValue = '';
            var hash = crypto.createHash('sha1');
            var input = fs.createReadStream(filename);
            if (input.read()) hash.update(data);else {
                checksumValue = hash.digest('hex');
            }
            return checksumValue;
        }
    }, {
        key: 'getHashValue',
        value: function getHashValue(selector) {
            var containingHashInfo = this.getContainingHashValue(selector);
            return containingHashInfo[containingHashInfo.length - 1].split('&')[0];
        }
    }, {
        key: 'getContainingHashValue',
        value: function getContainingHashValue(selector) {
            return this.getHrefValue(selector).split('=');
        }
    }, {
        key: 'getHrefValue',
        value: function getHrefValue(selector) {
            return $(selector).getAttribute('href').toString();
        }
    }]);

    return AttachmentHandling;
}();

module.exports = AttachmentHandling;