class ElementHandling {

    static element(selector, timeout = 30000, reverse = false) {
        browser.waitForVisible(selector, timeout, reverse);
        return $(selector);
    }

    static elements(selector, timeout = 30000) {
        browser.waitForVisible(selector, timeout);
        return $$(selector);
    }

    static isElementVisible(selector, timeout = 5000) {
        try {
            browser.waitForVisible(selector, timeout);
        } catch (ex) {
            console.log(ex.toString());
            return false;
        }
        return true;
    }

    static isElementEnabled(selector, timeout = 5000) {
        try {
            browser.waitForEnabled(selector, timeout);
        } catch (ex) {
            console.log(ex.toString());
            return false;
        }
        return true;
    }

    static scrollIntoViewByXpath(xpathInput) {
        browser.execute((xpath) => {
            console.log(xpath);
            document.evaluate(xpath, document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null)
                .singleNodeValue.scrollIntoView();
        }, xpathInput);
        browser.scroll(0, -100);
    }

    static hoverAndClick(selector) {
        browser.moveToObject(selector);
        $(selector).click();
    }

    static attachFile(selector, filePath, checkFuntion) {
        if (filePath) {
            browser.chooseFile(selector, filePath);
            console.log('Uploading file: ' + filePath);
            if (typeof checkFuntion !== 'undefined') {
                browser.waitUntil(checkFuntion === true, 60000, 'Uploading file is unsuccessful.');
            }
        } else {
            throw new Error('No file was input for attachment');
        }
    }

    selectCheckbox(selector, option) {
        if (typeof option !== "undefined") {
            let elem = this.element(selector);
            if (elem.isSelected() !== option) {
                elem.click();
            }
        }
        return this;
    }
}
module.exports = ElementHandling;