const $ = require('../element/ElementHandling').element;
let http = require('http');
let fs = require('fs');
let crypto = require('crypto');
const url = require('url');

class AttachmentHandling {

    static downloadFile(fileLocation, destLocation) {
        var file = fs.createWriteStream(destLocation);
        var request = http.get(fileLocation, function (response) {
            response.pipe(file);
        });
    }

    static downloadFileWithCookie(fileLocation, destLocation) {
        let cookie = browser.getCookie();
        let curUrl = browser.getUrl();
        console.log('FILE location:' + fileLocation);
        console.log('URL: ' + url.parse(curUrl).hostname);
        var file = fs.createWriteStream(destLocation);
        let options = {
            hostname: url.parse(curUrl).hostname,
            port: 80,
            path: fileLocation,
            method: 'GET',
            headers: {
                'Cookie': cookie[0].name + '=' + cookie[0].value
            }
        };

        let req = http.request(options, function (res) {
            console.log('Writing source file....');
            res.pipe(file);

            res.on('end', () => {
                console.log('No more data in response.');
            });
        });

        req.on('error', (e) => {
            console.error(`problem with request: ${e.message}`);
        });
        req.end();
    }

    static getFileChecksumSha1(fileLocation) {
        let checksumValue = '';
        const hash = crypto.createHash('sha1');
        const input = fs.createReadStream(filename);
        if (input.read())
            hash.update(data);
        else {
            checksumValue = hash.digest('hex');
        }
        return checksumValue;
    }

    static getHashValue(selector) {
        let containingHashInfo = this.getContainingHashValue(selector);
        return containingHashInfo[containingHashInfo.length - 1].split('&')[0];
    }

    static getContainingHashValue(selector) {
        return this.getHrefValue(selector).split('=');
    }

    static getHrefValue(selector) {
        return $(selector).getAttribute('href').toString();
    }
}
module.exports = AttachmentHandling;